/*
Copyright (c) 2014 by Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This program contains some code from the BSD kernel, which is copyrighted
by the Regents of the University of California. Their copyright statement
and software license is as follows:

 Copyright (c) 1986, 1988, 1991, 1993
	The Regents of the University of California.  All rights reserved.
 (c) UNIX System Laboratories, Inc.  All or some portions of this file
 are derived from material licensed to the University of California
 by American Telephone and Telegraph Co. or Unix System Laboratories,
 Inc. and are reproduced herein with the permission of UNIX System
 Laboratories, Inc.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met: 
 1. Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 4. Neither the name of the University nor the names of its contributors
    may be used to endorse or promote products derived from this software
    without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/
#line 2 "/tmp/usbdisks-1.0/src/main.u"
#include <stdio.h>
#include <stdint.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "mprintf.h"
#include "plist.h"
#include "fnmanip.c"
#include "eprintf.h"
#include "qsort_ptr.c"
#include "cmdline.h"
#include "gui.h"
#include "config.h"
#include "actions.h"

cfg_settings_t settings;
gui_ud_main_t *MW;
gui_devopt_t *DW;

static char *exit_arg;

#line 5 "/tmp/usbdisks-1.0/src/disk.u"

typedef struct {
  char *name;
  char *mounted;
  int gui_nr;
} part_t;

typedef struct {
   char *dev_name;
   char *model_name, *vendor_name;
   char *vendor_id, *model_id;
   char *serial_number;
     // this serial number also contains the vendor id and
     // product id. It's ready to use directly for identification
   char *serial;

   int nparts;
   part_t **parts;
   int gui_nr;
} disk_t;

#line 8 "/tmp/usbdisks-1.0/src/read_dir.u"

typedef struct { char *name; int type; } Tdirent;

#line 26 "/tmp/usbdisks-1.0/src/main.u"

static disk_t **disks; int ndisks;
#line 3 "/tmp/usbdisks-1.0/src/about.u"

static const char *H_about=
#line 57 "main.c"
"\n"
"Copyright (c) 2014 by \305\236\303\274kr\303\274 \303\207\304\261nar.\n"
"\n"
"All rights reserved.\n"
"\n"
"Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n"
"\n"
"1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n"
"\n"
"2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n"
"\n"
"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \042AS IS\042 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
"\n"
"This program contains some code from the BSD kernel, which is copyrighted by the Regents of the University of California. Their copyright statement and software license is as follows:\n"
"\n"
" Copyright (c) 1986, 1988, 1991, 1993\n"
"\011The Regents of the University of California.  All rights reserved.\n"
" (c) UNIX System Laboratories, Inc.\n"
" All or some portions of this file are derived from material licensed to the University of California by American Telephone and Telegraph Co. or Unix System Laboratories, Inc. and are reproduced herein with the permission of UNIX System Laboratories, Inc.\n"
"\n"
" Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n"
" 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n"
" 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n"
" 4. Neither the name of the University nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.\n"
"\n"
" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS\047\047 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
"\n"

#line 8 "/tmp/usbdisks-1.0/src/about.u"
;

static const char *H_help=
#line 89 "main.c"
"\n"
"GENERAL\n"
"\n"
"This program can be used only to mount or unmount USB disks. It can\047t be used for DVD drives or harddisks connected thru a SATA interface or similar.\n"
"\n"
"The program doesn\047t stay resident in memory. It simply quits when you close the main window. Also, it doesn\047t actively monitor currently connected devices. If you insert/remove a device while the program is running, simply click the \047Refresh\047 button on the \047Devices\047 tab in order to see the results.\n"
"\n"
"The program doesn\047t know anything about file systems on the devices it displays. It simply calls an external program to mount/unmount them.  Partition sizes, file system types etc. are not shown because of this.\n"
"\n"
"DEVICES TAB\n"
"\n"
"In the two lists, USB disk devices and their partitions are shown.  If a disk has only one partition, the partition isn\047t listed. Only the disk is displayed. \n"
"\n"
"Double-clicking a device or partition will mount it or umount it depending on which list it is in. In case of multiple partitions on a disk, double clicking it will mount or unmount all partitions on it depending on the list you do the double-clicking in.\n"
"\n"
"If you mount a disk or partition by double clicking, the mounted partition will be shown in your file browser program and the UsbDisks program will exit immediately. In case of multiple partitions, only the last mounted partition\047s directory will be shown.\n"
"\n"
"The \047Options\047 button at the bottom displays options for the selected device (single click). In order to view/edit general options regarding the whole program, switch over to the \047Settings\047 tab at the top.\n"
"\n"
"SETTINGS TAB\n"
"\n"
"File browser is used as explained in the previous section. xdg-open is usually a pretty good choice since it automatically runs your desktop file manager. No options or other things are allowed for this setting. It should simply be the absolute path to your file manager. Leaving it empty will cause the default to be used. \n"
"\n"
"The file manager should quit immediately when executed. The program waits for the file manager to finish so that it can show any error messages the file manager prints. xdg-open behaves this way. Thunar (file browser for xfce4) also behaves this way. If you want to use a program which doesn\047t do this, you can simply write a shell script which starts your program in the background and immediately exits.\n"
"\n"
"The mount program field is used for getting the path to the \047pmount\047 program. Note that UsbDisks will not work with another mounting program. This field is useful only if you have \047pmount\047 somewhere other than the default location.\n"
"\n"
"The following two flags define the default behaviour when mounting partitions. The first flag isn\047t very useful since \047pmount\047 somehow disables the exec flag on all files. The second one is honored, though. For information about what these flags mean, see the manual page for the \047mount\047 program.\n"
"\n"
"In order to undo your changes to the general settings, you can use the \047Reload\047 button. Of course this will work only if you haven\047t used the \047Save\047 button after doing your changes.\n"
"\n"
"MESSAGES TAB\n"
"\n"
"This tab displays error messages/warnings generated by this program or the external programs it runs. At the very least, you should see the message \047Scanning complete.\047 in this window. If you don\047t see that, there probably is something very wrong with the program.\n"
"\n"
"DEVICE OPTIONS WINDOW\n"
"\n"
"This window is displayed when you select a device or partition and click the \047Options\047 button from the \047Devices\047 tab. \n"
"\n"
"The \047Device Name\047 field lets you name a device and use that name for both mounting it and displaying the device in the program. It has no relation to \042volume names\042 in the partitions the device contains. It simply is a string stored on the computer, associated with the device using its serial number.\n"
"\n"
"If you leave this blank, the device will be displayed using the vendor and product names. For example, I get Sandisk:Cruzer_Edge for one of my disks when I leave this field empty. \n"
"\n"
"Below this are the options for individual partitions on the disk. The little list on the left contains the list of partitions from which you can select a partition and edit its options on the right.\n"
"\n"
"The two checkboxes in the partitions have the same meanings as in the \047Settings\047 tab. These override the general settings for the selected partition. \n"
"\n"
"You can specify a \047Mount Label\047 for the partition. This will be used as part of the directory name the partition will be mounted on.\n"
"\n"
"MOUNT POINT NAMING\n"
"\n"
"When you mount a partition, it will be mounted in a freshly created directory in \047/media\047. There are a couple of rules regarding how this name is computed. In any case, the mount directory will be prefixed by the device name.\n"
"\n"
"If the disk has only one partition and the partition has no mount label, then the directory name will be the same as the device name.\n"
"\n"
"If the disk has only one partition and it does have a mount label, then the directory name will be \047device_name-mount_label\047.\n"
"\n"
"If the disk has multiple partitions, the directory name will be \047device_name-mount_label\047 for partitions with defined mount labels and \047device_name-volN\047 for partitions without mount labels.\n"
"\n"

#line 14 "/tmp/usbdisks-1.0/src/about.u"
;

#line 111 "/tmp/usbdisks-1.0/src/device_options.u"

static cfg_device_t  DEVOdev, DEVMdev;
static cfg_volume_t *DEVOvol, *DEVMvol;
static int DEVnvol, DEVsel;

#line 29 "/tmp/usbdisks-1.0/src/main.u"

#line 160 "main.c"

void read_dir(const char *dname, Tdirent ***Rp, int *Rn);
static int run_prg(char **argv);
static int mount_part(disk_t *D, part_t *P);
static int umount_part(disk_t *D, part_t *P);
void refresh_display();
void destroy_disk(disk_t *D);
char *part_name(disk_t *D,part_t *P);
void nullfree(void *X);
static void display_settings();
void clear_messages() ;
void click_save_settings();
void click_reload_settings();
void read_config();
void click_refresh();
void about_box(int w);
static void display_partitions();
disk_t *find_disk_gui_nr(int nr);
part_t *find_part_gui_nr(int nr,disk_t **Rd);
void *pmax(void *a, void *b) ;
char *pretty_disk_name(disk_t *D);
static void get_part_settings
    (disk_t *D, part_t *P, int *exec, int *noatime);
static cfg_volume_t *get_part_config(disk_t *D, part_t *P);
static int part_number(part_t *P);
void remove_device_settings(disk_t *D, cfg_device_t *Rdev,
                                       cfg_volume_t **Rvols,int *Rnvols);
static int sort_unify_volumes(cfg_volume_t *vols, int n);
void start_devopts(disk_t *D);
void click_devopts_vol(int nr);
static void read_partops(int nr);
static void write_partops(int nr);
static void insert_device_options
   (cfg_device_t *devopt, cfg_volume_t *volopt, int nvol);
void close_devopts(int act) ;
static void print_settings();
void print_str(int flag, char *title, char *data);
void print_int(int flag, char *title, int data);
static void get_device_list(char ***R, int *Rn);
static int starts_with(char *str, char *pfx);
static char *get_device_info(char *devname, disk_t **R);
char **divide_into_lines(char *str, int strsz);
static void get_disk_param(char *line, disk_t *D);
void get_disks(disk_t ***R, int *Rn);
static int ends_with_digit(char *X);
static void disk_attach_partitions(disk_t *D, char **devnames, int ndevnames);
static int partcmp(part_t *a, part_t *b, void *arg);
static int is_removable_device(char *devname);
void unify_str_list(char **SL, int *N);
int sanitize_str(unsigned char *str);
void output_config(FILE *F);
void string_out(FILE *f, char *flag, char **str, char *name);
void int_out(FILE *f, int flag, int v, char *name);
void save_config();
void find_mounted_partitions(disk_t **disks,int ndisks);
static void check_mounted(char *dev, char *path, disk_t **disks, int ndisks);
#line 34 "/tmp/usbdisks-1.0/src/main.u"


#line 12 "/tmp/usbdisks-1.0/src/read_dir.u"

void read_dir(const char *dname, Tdirent ***Rp, int *Rn)
{
  DIR *dir;
  int name_max;
  struct dirent *entry,*result;
  plist_t *L;
  int R;
  Tdirent *DE;

  *Rp= NULL; *Rn= 0;

  dir= opendir(dname);
  if (!dir)
  {
    eprintf("opendir(%s): %s\n", dname, strerror(errno));
    return ;
  }

  name_max = pathconf(dname, _PC_NAME_MAX);
  if (name_max == -1) name_max = 255;
  entry= malloc(sizeof(struct dirent)+name_max);

  L= plist();
again:
  R= readdir_r(dir, entry, &result);
  if (R)
  {
    eprintf("readdir(%s): %s\n", dname,strerror(R));
    goto dir_read_done;
  }
  if (!result) goto dir_read_done;
  if (!strcmp(result->d_name, ".") || !strcmp(result->d_name,".."))
     goto again;
  DE= malloc(sizeof(*DE));
  DE->name= strdup(result->d_name);
  DE->type= result->d_type;
  plista(L, DE);
  goto again;

dir_read_done:
  closedir(dir);
  free(entry);

  plistg(L, (void***) Rp, Rn);
}
#line 183 "/tmp/usbdisks-1.0/src/main.u"

static int run_prg(char **argv)
{
  char *pout, *perr; size_t perrl, poutl; int pr, pst;
  int i;

  pr= proc_run(argv[0], argv, &pst, NULL, 0, &pout, &poutl, &perr, &perrl);
  if (pout && poutl)
    eprintf("%s output:\n%s\n", argv[0], pout);
  if (perr && perrl)
    eprintf("%s error stream:\n%s\n", argv[0], perr);
  if (pout) free(pout);
  if (perr) free(perr);

  for(i=0;argv[i];i++) free(argv[i]);

  return pr;
}

static int mount_part(disk_t *D, part_t *P)
{
  int i; char *argv[100];
  char *pname;
  int Fexec, Fnoatime;

  if (P->mounted)
  { 
    eprintf("partition %s is already mounted\n", P->name);
    return ;
  }
  eprintf("mount %s\n", P->name);

  get_part_settings(D,P, &Fexec, &Fnoatime);

  i= 0;
  argv[i++]= strdup("/usr/bin/pmount");
  if (Fexec)    argv[i++]= strdup("-e");
  if (Fnoatime) argv[i++]= strdup("-A");
  argv[i++]= mprintf("/dev/%s", P->name);
  pname= strdup(argv[i++]= part_name(D,P));
  argv[i++]= NULL;

  if (!run_prg(argv)) { exit_arg= pname; return 0; }
  return 1;
}

static int umount_part(disk_t *D, part_t *P)
{
  int i; char *argv[100];
  if (!P->mounted)
  {
    eprintf("partition %s is not mounted\n", P->name);
    return ;
  }
  i= 0;
  argv[i++]= strdup("/usr/bin/pumount");
  argv[i++]= mprintf("/dev/%s", P->name);
  argv[i++]= NULL;
  return run_prg( argv );
}

void refresh_display()
{
  int i;
  gui_clear(MW->ud_mounted);
  gui_clear(MW->ud_unmounted);
  for(i=0;i<ndisks;i++) destroy_disk(disks[i]);
  if (disks) free(disks);
  get_disks(&disks, &ndisks);
  find_mounted_partitions(disks, ndisks);
  display_partitions();
}


void destroy_disk(disk_t *D)
{
  int i;
  nullfree(D->vendor_name); nullfree(D->model_name);
  nullfree(D->serial); nullfree(D->dev_name);
  nullfree(D->vendor_id); nullfree(D->model_id);
  nullfree(D->serial_number);
  for(i=0;i<D->nparts;i++) nullfree(D->parts[i]->name);
  for(i=0;i<D->nparts;i++) nullfree(D->parts[i]->mounted);
  for(i=0;i<D->nparts;i++) nullfree(D->parts[i]);
  free(D->parts);
  free(D);
}

char *part_name(disk_t *D,part_t *P)
{
   char *Dn,*Pn; int nr;
   cfg_volume_t *VC;

   Dn= pretty_disk_name(D);

   VC= get_part_config(D,P);
   if (!VC || !VC->G_mount_point)
   {
      if (D->nparts==1) return strdup(Dn);
      nr= part_number(P);
      if (nr==0) Pn= strdup(P->name);
            else Pn= mprintf("vol%d",nr);
   } else Pn= VC->mount_point;

   return mprintf("%s-%s", Dn, Pn);
}

void nullfree(void *X)
{
   if (X) free(X);
}

#line 296 "/tmp/usbdisks-1.0/src/main.u"

static void display_settings()
{
  gui_set_value(MW->opexec,settings.G_exec && settings.exec);
  gui_set_value(MW->opnoatime,settings.G_noatime && settings.noatime);

  if (settings.G_file_browser && settings.file_browser[0])
     gui_set_text(MW->file_browser, settings.file_browser);
  else
     gui_set_text(MW->file_browser, "");

  if (settings.G_mount_program && settings.mount_program[0])
     gui_set_text(MW->mount_prg, settings.mount_program);
  else
     gui_set_text(MW->mount_prg, "");
}

void clear_messages() { gui_clear(MW->message); }


void click_save_settings()
{
  settings.G_file_browser= 1;
  settings.file_browser= gui_get_text(MW->file_browser);

  settings.G_mount_program= 1;
  settings.mount_program= gui_get_text(MW->mount_prg);

  settings.G_exec= 1;
  gui_get_value(MW->opexec, &settings.exec);

  settings.G_noatime= 1;
  gui_get_value(MW->opnoatime, &settings.noatime);

  save_config();
  display_settings();
}

void click_reload_settings()
{
  memset(&settings, 0, sizeof(settings));
  read_config();
  display_settings();
  refresh_display();
}


void read_config()
{
  char *E;
  char *home;
  char *fname;
  
  home= getenv("HOME");
  if (!home) fname= strdup("/etc/UsbDisks.conf");
  else fname= mprintf("%s/.config/UsbDisks/UsbDisks.conf",home);
  
  E= cfg_parse_settings(fname, &settings);
  free(fname);
  if (E) {
    eprintf("error reading settings: %s\n", E);
    return ; 
  }
}

void click_refresh()
{
  refresh_display();
}
#line 17 "/tmp/usbdisks-1.0/src/about.u"

void about_box(int w)
{
   const char *T;
   if (w==1) T= H_about;
   else T= H_help;
   gui_clear(MW->about);
   gui_append(MW->about, T, strlen(T));
}

#line 5 "/tmp/usbdisks-1.0/src/display_dev.u"

static void display_partitions()
{
   int i,j,mounted_device_print,unmounted_device_print;
   char *K;
   int gui_nr;

   gui_nr= 1;
   for(i=0;i<ndisks;i++)
   {
     disks[i]->gui_nr= gui_nr++;
     for(j=0;j<disks[i]->nparts;j++)
         disks[i]->parts[j]->gui_nr= gui_nr++;
   }

   for(i=0;i<ndisks;i++)
   {
      disk_t *D;
      D= disks[i];

      if (D->nparts==0) continue; // nothing is shown for it.
      if (D->nparts==1)
      {
         if (D->parts[0]->mounted)
         {
            K= mprintf("%s : %s", pretty_disk_name(D), D->parts[0]->mounted);
            gui_list_append(MW->ud_mounted, K, D->gui_nr);
         } else {
            K= mprintf("%s ", pretty_disk_name(D));
            gui_list_append(MW->ud_unmounted, K, D->gui_nr);
         }
         continue;
      }

      mounted_device_print= unmounted_device_print= 0;

      for(j=0;j<D->nparts;j++)
      {
        if (D->parts[j]->mounted)
        {
          if (!mounted_device_print)
          {
            gui_list_append(MW->ud_mounted, pretty_disk_name(D), D->gui_nr);
            mounted_device_print= 1;
          }
          K= mprintf("    %s : %s", D->parts[j]->name, D->parts[j]->mounted);
          gui_list_append(MW->ud_mounted, K, D->parts[j]->gui_nr);
        } else {
          if (!unmounted_device_print)
          {
            gui_list_append(MW->ud_unmounted, pretty_disk_name(D), D->gui_nr);
            unmounted_device_print= 1;
          }
          K= mprintf("    %s", D->parts[j]->name);
          gui_list_append(MW->ud_unmounted, K, D->parts[j]->gui_nr);
        }
      }
   }
}


#line 70 "/tmp/usbdisks-1.0/src/display_dev.u"

disk_t *find_disk_gui_nr(int nr)
{
   int i;
   for(i=0;i<ndisks;i++)
     if (disks[i]->gui_nr==nr) return disks[i];
   return NULL;
}

part_t *find_part_gui_nr(int nr,disk_t **Rd)
{
   int i,j;
   for(i=0;i<ndisks;i++)
     for(j=0;j<disks[i]->nparts;j++)
     if (disks[i]->parts[j]->gui_nr==nr)
     {
       *Rd= disks[i];
       return disks[i]->parts[j];
     }
   return NULL;
}
#line 4 "/tmp/usbdisks-1.0/src/pretty_name.u"

void *pmax(void *a, void *b) { if (a) return a; return b; }

char *pretty_disk_name(disk_t *D)
{
   int i;
   char *part1, *part2;

   if (!D->serial) goto failed;
   for(i=0;i<settings.N_device;i++)
   {
    if (!settings.device[i].G_serial) continue;
    if (strcmp(settings.device[i].serial, D->serial)) continue;
    if (!settings.device[i].G_pretty_name) goto failed;
    return settings.device[i].pretty_name;
   }
failed:
   part1= part2= NULL;

   part1= pmax( pmax(D->vendor_name, D->vendor_id), 
                pmax(pmax(D->model_name, D->model_id), D->dev_name));

   part2= pmax(pmax(D->model_name, D->model_id), D->dev_name);

   if (part1==part2) return part1;
   else return mprintf("%s:%s", part1, part2);
}


#line 2 "/tmp/usbdisks-1.0/src/part_settings.u"

static void get_part_settings
    (disk_t *D, part_t *P, int *exec, int *noatime)
{
   cfg_volume_t *V;

   *exec= *noatime= 0;
   if (settings.G_exec)    *exec= settings.exec; 
   if (settings.G_noatime) *noatime= settings.noatime; 

   V= get_part_config(D,P);
   if (!V) return ;

   if (V->G_exec)          *exec= V->exec;
   if (V->G_noatime)       *noatime= V->noatime;
}


static cfg_volume_t *get_part_config(disk_t *D, part_t *P)
{
   int i;
   int nr;

   nr= part_number(P);

   if (!D->serial) return NULL;
   for(i=0;i<settings.N_volume;i++)
     if ((settings.volume[i].G_device_serial) &&
         (!strcmp(settings.volume[i].device_serial, D->serial)) &&
         (settings.volume[i].number==nr))
       return settings.volume+i;
   return NULL;
}

static int part_number(part_t *P)
{
  char *K;
  for(K= P->name;K[0];K++)
     if (isdigit(K[0])) break;
  if (!K[0]) return 1;
  return atoi(K);
}


#line 9 "/tmp/usbdisks-1.0/src/device_options.u"

void remove_device_settings(disk_t *D, cfg_device_t *Rdev,
                                       cfg_volume_t **Rvols,int *Rnvols)
{
   int i,j,n;
   cfg_volume_t *vols;
   char *serial;
   
   memset(Rdev, 0, sizeof(*Rdev));
   serial= strdup(D->serial);
   Rdev->serial= serial;
   Rdev->G_serial= 1;
  

   for(i=0;i<settings.N_device;i++)
     if (settings.device[i].G_serial && 
         !strcmp(settings.device[i].serial, D->serial))
     {
        *Rdev= settings.device[i];
        settings.device[i]= settings.device[settings.N_device-1];
        settings.N_device--;
        break;
     }

   vols= calloc(D->nparts,sizeof(cfg_volume_t));
   for(i=0;i<D->nparts;i++) 
   {
     vols[i].G_number= 1;
     vols[i].number= part_number(D->parts[i]); 
     vols[i].G_device_serial= 1;
     vols[i].device_serial= serial;
   }

   n= sort_unify_volumes(vols, D->nparts);

   for(i=0;i<settings.N_volume;i++)
   {
      cfg_volume_t *V= settings.volume+i;

      if (!V->G_device_serial || strcmp(V->device_serial,D->serial))
         continue;

      if (!V->G_number) continue;

      for(j=0;j<n;j++)
        if (V->number==vols[j].number)
        {
          vols[j]= *V;
          break;
        }

      settings.volume[i]= settings.volume[settings.N_volume-1];
      settings.N_volume--;
      i--;
   }

   *Rvols= vols;
   *Rnvols= n;
}

#line 70 "/tmp/usbdisks-1.0/src/device_options.u"

static int sort_unify_volumes(cfg_volume_t *vols, int n)
{
   int i,j;
   cfg_volume_t T;

   if (n==0) return 0;

#if 0
   for(i=0;i<n;i++)
     if (vols[i].number<=0)
     {
       vols[i]= vols[n-1];
       n--; i--;
     }

   if (n==0) return 0;
    This is fucking stupid. sr0 is causing lots of problems
    for me..
#endif

   for(i=0;i<n-1;i++)
     for(j=i+1;j<n;j++)
       if (vols[i].number>vols[j].number)
       {
         T= vols[i];
         vols[i]= vols[j];
         vols[j]= T;
       }

   j=0;
   for(i=1;i<n;i++)
     if (vols[i].number!=vols[j].number)
       vols[++j]= vols[i];
   return j+1;  
}

#line 117 "/tmp/usbdisks-1.0/src/device_options.u"

void start_devopts(disk_t *D)
{
  int sz;
  int i;

#if 0
  printf("INITIAL\n");
  print_settings();
  printf("END\n");
#endif

  remove_device_settings(D, &DEVOdev, &DEVOvol, &DEVnvol);
  if (DEVnvol==0)
  {
    eprintf("No usable volumes are found for disk %s\n"
            "Quitting options screen.\n", pretty_disk_name(D));
    return ;
  }
  sz= DEVnvol*sizeof(cfg_volume_t);
  DEVMdev= DEVOdev;
  DEVMvol= malloc(sz);
  memcpy(DEVMvol, DEVOvol, sz);

  gui_set_text(DW->vendor, D->vendor_name ? D->vendor_name : "");
  gui_set_text(DW->model, D->model_name ? D->model_name : "");
  gui_set_text(DW->serial, D->serial);

  gui_set_text(DW->pretty_name, 
                 DEVMdev.pretty_name ? DEVMdev.pretty_name : ""); 
  DEVsel= -1; 

  for(i=0;i<DEVnvol;i++)
  {
    char buf[20];
    sprintf(buf,"vol%d", DEVMvol[i].number);
    gui_list_append(DW->parts, buf, DEVMvol[i].number);
  }
}


#line 164 "/tmp/usbdisks-1.0/src/device_options.u"

void click_devopts_vol(int nr)
{
   int i;
   char buf[200];
   if (DEVsel!=-1)
   {
      read_partops(DEVsel);
      gui_set_text(DW->selpart, "");
      gui_select_item(DW->parts, DEVsel, 0);
      DEVsel= -1;
   }
   for(i=0;i<DEVnvol;i++) if (DEVMvol[i].number==nr) break;
   if (i==DEVnvol) return ;
   DEVsel= nr;
   gui_select_item(DW->parts, DEVsel, 1);
   sprintf(buf,"vol%d", nr);
   gui_set_text(DW->selpart, buf);
   write_partops(DEVsel);
}

#line 186 "/tmp/usbdisks-1.0/src/device_options.u"

static void read_partops(int nr)
{
   int i;
   cfg_volume_t *V;

   for(i=0;i<DEVnvol;i++) if (DEVMvol[i].number==nr) break;
   if (i==DEVnvol) return ;
   V= DEVMvol+i;

   V->G_exec= 1; gui_get_value(DW->opexec, &V->exec);
   V->G_noatime= 1; gui_get_value(DW->opnoatime, &V->noatime);
   V->G_mount_point=1; V->mount_point= gui_get_text(DW->mount_label);
}

static void write_partops(int nr)
{
   int i;
   cfg_volume_t *V;

   for(i=0;i<DEVnvol;i++) if (DEVMvol[i].number==nr) break;
   if (i==DEVnvol) return ;
   V= DEVMvol+i;

   gui_set_value(DW->opexec, V->G_exec ? V->exec : 0);
   gui_set_value(DW->opnoatime, V->G_noatime ? V->noatime : 0);
   gui_set_text(DW->mount_label, V->G_mount_point ? V->mount_point : "");
}

#line 220 "/tmp/usbdisks-1.0/src/device_options.u"

static void insert_device_options
   (cfg_device_t *devopt, cfg_volume_t *volopt, int nvol)
{
   int i;
   if (settings.N_device == settings.S_device)
   {
     settings.S_device+= 4;
     settings.device= realloc(settings.device, 
              sizeof(cfg_device_t)*settings.S_device);
   }
   settings.device[settings.N_device]= *devopt;
   settings.N_device++;

   if (settings.N_volume+nvol > settings.S_volume)
   {
      settings.S_volume+= nvol + 4;
      settings.volume= realloc(settings.volume,
               sizeof(cfg_volume_t)*settings.S_volume);
   }
   for(i=0;i<nvol;i++)
     settings.volume[settings.N_volume++]= volopt[i];
}

#line 249 "/tmp/usbdisks-1.0/src/device_options.u"

void close_devopts(int act) {
  if (act==0)
     insert_device_options(&DEVOdev, DEVOvol, DEVnvol);
  else {
     DEVMdev.G_pretty_name= 1;
     DEVMdev.pretty_name= gui_get_text(DW->pretty_name);
     if (DEVsel!=-1) read_partops(DEVsel);
     insert_device_options(&DEVMdev, DEVMvol, DEVnvol);
  }
  DEVsel= -1;
  gui_close(*DW);

  if (act==1)
  {
    save_config();
    refresh_display();
  }

}

static void print_settings()
{
  int i;
  printf("settings\n");
  print_str(settings.G_file_browser, "File Browser", settings.file_browser);
  print_str(settings.G_mount_program, "Mount Program", settings.mount_program);

  for(i=0;i<settings.N_device;i++)
  {
     printf("device\n");
     print_str(settings.device[i].G_serial,
            "Serial", settings.device[i].serial);
     print_str(settings.device[i].G_pretty_name,
            "Pretty Name", settings.device[i].pretty_name);
  }
  for(i=0;i<settings.N_volume;i++)
  {
     printf("volume\n");
     print_str(settings.volume[i].G_device_serial,
               "Device Serial", settings.volume[i].device_serial);
     print_str(settings.volume[i].G_mount_point,
               "Mount Point", settings.volume[i].mount_point);
     print_int(settings.volume[i].G_exec,
               "Exec", settings.volume[i].exec);
     print_int(settings.volume[i].G_noatime,
               "Noatime", settings.volume[i].noatime);
  }
}

void print_str(int flag, char *title, char *data)
{
  if (flag) printf("%s: %s\n",title,data);
}

void print_int(int flag, char *title, int data)
{
  if (flag) printf("%s: %d\n", title,data);
}
#line 16 "/tmp/usbdisks-1.0/src/find_usb_disks.u"

static void get_device_list(char ***R, int *Rn)
{
   int i;
   char *refdir;
   Tdirent **byid; int nbyid;
   char linkbuf[1024]; ssize_t linklen; 
   plist_t *L;
   char *N,*devname; 

   refdir= "/dev/disk/by-id";
   read_dir(refdir, &byid, &nbyid);
   i= nbyid-1;
   L= plist();

again:
   if (i<0) goto done;
 //  if (!starts_with(byid[i]->name, "usb-") || byid[i]->type!=DT_LNK)
   if (byid[i]->type!=DT_LNK)
      goto next_entry;

   N= fnmani_child(refdir, byid[i]->name);
   linklen= readlink(N, linkbuf, sizeof(linkbuf)-1);
   if (linklen<0) { free(N); goto next_entry; }
   linkbuf[linklen]= 0;
   free(N);

   devname= fnmani_file(linkbuf);
   if (!devname[0]) { free(devname); goto next_entry; }

   plista(L, devname);

next_entry:
   free(byid[i]->name); free(byid[i]);
   i--;
   goto again;
done:
   plistg(L, (void***) R, Rn);
   if (byid) free(byid);
   unify_str_list(*R, Rn);
}

static int starts_with(char *str, char *pfx)
{
   int Ls, Lp;
   Ls= strlen(str);
   Lp= strlen(pfx);
   if (Ls<Lp) return 0;
   if (memcmp(str,pfx, Lp)) return 0;
   return 1;
}

#line 73 "/tmp/usbdisks-1.0/src/find_usb_disks.u"

static char *get_device_info(char *devname, disk_t **R)
{
  int i;
  char *argv[10];
  char *fullname;
  char *pout, *perr; size_t poutl, perrl; int pr, st;
  disk_t *disk;
  char **lines;

  *R= NULL;
  
  i= 0;
  argv[i++]= "/usr/bin/udevadm";
  argv[i++]= "info";
  fullname= fnmani_child("/dev", devname);
  argv[i++]= fullname;
  argv[i++]= NULL;
  
  pr= proc_run(argv[0], argv, &st, NULL, 0, &pout, &poutl, &perr, &perrl);
  free(fullname);
  if (!pout || !poutl) 
  {
    eprintf("Error running udevadm\n");
    if (perr && perrl)
      eprintf("Error stream from the child was:\n%s\n", perr);
    if (perr) free(perr);
    return ;
  }

  if (perr) free(perr);

  lines= divide_into_lines(pout, poutl);
  free(pout);
  disk= calloc(1,sizeof(*disk));
  for(i=0;lines[i];i++)
  {
    get_disk_param(lines[i], disk);
    free(lines[i]);
  }
  free(lines);

  if (disk->serial_number)
    disk->serial= mprintf("%s:%s:%s", disk->vendor_id? disk->vendor_id : "U",
                                      disk->model_id? disk->model_id : "U",
                                      disk->serial_number);
  else
    disk->serial= strdup("");
  disk->dev_name= devname;
  *R= disk;
  return NULL;
}


#line 128 "/tmp/usbdisks-1.0/src/find_usb_disks.u"

char **divide_into_lines(char *str, int strsz)
{
  char *B,*E,*end,*S;
  plist_t *L;
  void **K; int Kn;

  end= str+strsz;

  L= plist();
  B= str;
again:
  E= memchr(B, '\n', strsz);
  if (!E) E= end;
  S= malloc(E-B+1);
  memcpy(S, B, E-B);
  S[E-B]= 0;
  plista(L, S);
  B= E+1;
  if (B<end) goto again;

  plista(L, NULL);
  plistg(L, &K, &Kn);
  return (char**) K;
}

static void get_disk_param(char *line, disk_t *D)
{
  if (strlen(line)<=2 || line[0]!='E' || line[1]!=':') return ;
  line+= 2;
  while(isspace(line[0])) line++;
  if (!line[0]) return ;
#define FIELD(X,Y) \
  if (starts_with(line,X)) { if (D->Y) free(D->Y); \
                             D->Y= strdup(line+strlen(X)); return ; }

  FIELD("ID_VENDOR_ID=", vendor_id)
  FIELD("ID_MODEL_ID=", model_id)
  FIELD("ID_SERIAL=", serial_number)
  FIELD("ID_VENDOR=", vendor_name)
  FIELD("ID_MODEL=", model_name)
#undef FIELD
}

#line 176 "/tmp/usbdisks-1.0/src/find_usb_disks.u"

void get_disks(disk_t ***R, int *Rn)
{
   char **device_names;
   int ndevice_names;
   int i; char *devname;
   disk_t *D;

   plist_t *L;
   L= plist();

   *R= NULL; *Rn= 0;

   get_device_list(&device_names, &ndevice_names);
   for(i=0;i<ndevice_names;i++)
   {
      if (!device_names[i]) continue;
      // oh, what the heck. is_removable_device will already
      // fail for partitions, so I can remove the following
      // condition. I have to do this because the fucking
      // DVD drive does end with a digit. it's called sr0. 
      // pah.
      // if (ends_with_digit(device_names[i])) continue;
      if (!is_removable_device(device_names[i])) continue;
      devname= device_names[i];
      device_names[i]= NULL;

      get_device_info(devname, &D);
      if (!D) { free(devname); continue; }

      plista(L, D);
      disk_attach_partitions(D, device_names, ndevice_names);
   }

   for(i=0;i<ndevice_names;i++)
      if (device_names[i]) free(device_names[i]);
   free(device_names);

   plistg(L, (void***) R, Rn);
}

#line 218 "/tmp/usbdisks-1.0/src/find_usb_disks.u"

static int ends_with_digit(char *X)
{
  char *K= strlen(X) + X -1;
  if (K<X) return 0;
  return isdigit(K[0]);
}

#line 227 "/tmp/usbdisks-1.0/src/find_usb_disks.u"

static void disk_attach_partitions(disk_t *D, char **devnames, int ndevnames)
{
  int i;
  plist_t *L;
  char *K;
  part_t *P;
  int N;

  L= plist();
  N= 0;

  for(i=0;i<ndevnames;i++)
    if (devnames[i] && starts_with(devnames[i], D->dev_name))
    {
      K= devnames[i]+strlen(D->dev_name);
      while(isdigit(K[0])) K++;
      if (K[0]) continue;
      P= calloc(1,sizeof(*P));
      P->name= devnames[i];
      plista(L, P);
      devnames[i]= NULL;
      N++;
    }


  if (!N)
  {
      P= calloc(1,sizeof(*P));
      P->name= strdup(D->dev_name);
      plista(L, P);
  }
  plistg(L, (void***) &D->parts, &D->nparts);
  quicksort_ptr( (void**) D->parts, D->nparts, (void*) partcmp, NULL);
}

#line 264 "/tmp/usbdisks-1.0/src/find_usb_disks.u"

static int partcmp(part_t *a, part_t *b, void *arg)
{
  return strcmp(a->name, b->name);
}

static int is_removable_device(char *devname)
{
   char namebuf[2000];
   char buf[2000];
   char *c;
   FILE *f;
   int R;
   sprintf(namebuf,"/sys/block/%s/removable", devname);
   f= fopen(namebuf, "r");
   if (!f) goto second_method;
   R= fgets(buf, sizeof(buf), f) && strtol(buf, NULL, 0);
   fclose(f);
   if (R) return R;
second_method:
// last resort, if /sys/block/sdc is a link,
// and it contains usb somewhere in its path,
// just assume that it is indeed removable

   sprintf(namebuf,"/sys/block/%s", devname);
   R= readlink(namebuf, buf, sizeof(buf)-1);
   if (R<0) return 0;
   buf[R]= 0;
   c= strstr(buf,"usb"); 
   if (!c) return 0;
// make sure that the string 'usb' isn't just part of the
// disk name or something.
   if (strchr(c,'/')) return 1;
   return 0;
}

void unify_str_list(char **SL, int *N)
{
   int n,i,j;
   n= *N;
   for(i=0;i<n-1;i++)
     for(j=i+1;j<n;j++)
       if (!strcmp(SL[i],SL[j]))
       {
         SL[j]= SL[n-1];
         n--; j--;
       }
   *N= n;
}

#line 10 "/tmp/usbdisks-1.0/src/save_opts.u"

int sanitize_str(unsigned char *str)
{
  int i,L;
  for(i=0;str[i];i++)
  {
    if (str[i]<' ' || str[i]==127) str[i]= ' ';
    if (str[i]=='"' || str[i]=='\'') str[i]= '_';
  }

  while(isspace(str[0]))
    memmove(str, str+1, strlen(str));

  L= strlen(str)-1;
  while(L>=0 && isspace(str[L]))
    { str[L]= 0; L--; }

  if (str[0]) return 1;
  return 0;
}

#line 32 "/tmp/usbdisks-1.0/src/save_opts.u"

void output_config(FILE *F)
{
  int i;

  string_out(F, &settings.G_mount_program,
                &settings.mount_program, "mount_program");
  string_out(F, &settings.G_file_browser,
                &settings.file_browser, "file_browser");
  int_out(F, settings.G_exec, settings.exec, "exec");
  int_out(F, settings.G_noatime, settings.noatime, "noatime");

  for(i=0;i<settings.N_device;i++)
  {
    cfg_device_t *D= settings.device+i;
    fprintf(F,"device {\n");
    string_out(F, &D->G_serial, &D->serial, "serial");
    string_out(F, &D->G_pretty_name, &D->pretty_name, "pretty_name");
    fprintf(F,"}\n");
  }

  for(i=0;i<settings.N_volume;i++)
  {
    cfg_volume_t *V= settings.volume+i;
    fprintf(F,"volume {\n");
    string_out(F, &V->G_device_serial, &V->device_serial, "device_serial");
    string_out(F, &V->G_mount_point, &V->mount_point, "mount_point");
    int_out(F, V->G_exec, V->exec, "exec");
    int_out(F, V->G_noatime, V->noatime, "noatime");
    int_out(F, V->G_number, V->number, "number");
    fprintf(F,"}\n");
  }
}


void string_out(FILE *f, char *flag, char **str, char *name)
{
   if (!*str) return ;
   if (!*flag) { *str= NULL; return ; }
   *flag= sanitize_str(*str);
   if (!*flag) { *str= NULL; return ; }

   fprintf(f,"%s \"%s\"\n", name, *str);
}

void int_out(FILE *f, int flag, int v, char *name)
{
   if (flag)
     fprintf(f,"%s %d\n", name, v);
}

void save_config()
{
   FILE *f;
   char *home;
   char *path;
   char *dir;

   home= getenv("HOME");
   if (!home)
   { 
     eprintf("Can't save config file, $HOME is not set\n");
     return ;
   }

   path= mprintf("%s/.config/UsbDisks/UsbDisks.conf", home);
   f= fopen(path,"w");
   if (!f)
   {
     int eno;
     eno= errno;
     if (eno!=ENOENT)
     {
       eprintf("Couldn't open file %s for writing: %s\n"
               "Aborting save config.\n", path, strerror(eno));
       return ;
     }
     eprintf("ENOENT during configuration save, trying to make directories\n");
     dir= mprintf("%s/.config",home);
     mkdir(dir, 0700); free(dir);
     dir= mprintf("%s/.config/UsbDisks",home);
     mkdir(dir, 0700); free(dir);
     f= fopen(path,"w");
     if (!f)
     {
       eprintf("Couldn't open file %s for writing: %s\n"
               "Aborting save config.\n", path, strerror(eno));
       return ;
     }
   }

   output_config(f);
   fclose(f);
   eprintf("Configuration saved.\n");
}

#line 6 "/tmp/usbdisks-1.0/src/find_mounted_parts.u"

void find_mounted_partitions(disk_t **disks,int ndisks)
{
  int pr, pst; char *pout, *perr; size_t poutl, perrl;
  int argc; char *argv[10];
  int i,j; int worderr; char **words; char **lines;

  i= 0;
  argv[i++]= "/usr/bin/mount";
  argv[i++]= NULL;

  pr= proc_run(argv[0], argv, &pst, NULL, 0, &pout, &poutl, &perr, &perrl);

  if (perr && perrl)
    eprintf("'mount' error stream:\n%s\n", perr);
  if (perr) free(perr);

  if (!pout || !poutl) { if (pout) free(pout); return ; }
   
  lines= divide_into_lines(pout, poutl);
  free(pout);
  i= 0;
again:
  if (!lines[i]) goto done;

  if (!starts_with(lines[i], "/dev/")) goto next_line;

  words= parse_cmd_line(lines[i], &worderr);
  if (!words) goto next_line;
  if (!words[0] || !words[1] || !words[2] || strcmp(words[1], "on"))
      goto free_words_next_line;

  check_mounted(words[0], words[2], disks, ndisks);

free_words_next_line:
  for(j=0;words[j];j++) free(words[j]);
  free(words);
next_line:
  free(lines[i]);
  i++;
  goto again;
done:
  free(lines);
}

#line 52 "/tmp/usbdisks-1.0/src/find_mounted_parts.u"

static void check_mounted(char *dev, char *path, disk_t **disks, int ndisks)
{
  char  *ref;
  int i,j; disk_t *D; part_t *P;

  ref= "/dev/";
  if (!starts_with(dev,ref)) return ;
  dev+= strlen(ref);
  if (!dev[0]) return ;

  for(i=0;i<ndisks;i++)
  {
    D= disks[i];
    for(j=0;j<D->nparts;j++)
    {
      P= D->parts[j];
      if (!strcmp(P->name, dev))
      {
         if (P->mounted) free(P->mounted);
         P->mounted= strdup(path);
         return ;
} } } }


#line 38 "/tmp/usbdisks-1.0/src/main.u"


void print_dirent(Tdirent *A)
{
  printf("%2d %s\n", A->type, A->name);
}

void writeF(void *F, char *s, size_t L)
{
   fwrite(s, 1, L, F);
}

char *unks(char*X) { return X? X: "U"; }
static void msgout(void *arg, char *V, size_t L)
{
  gui_append(MW->message, V, L);
}


int main(int argc,char **argv)
{
  int i,j;

  //eprintf_attach(writeF, stderr, 'r');

  read_config();
  gui_init(&argc,argv);
  MW= gui_c_ud_main();

  eprintf_attach(msgout, NULL, 'r');
  about_box(1);
  display_settings();

  refresh_display();

  eprintf("Scanning complete\n");

  for(i=0;i<ndisks;i++)
  {
    disk_t *F= disks[i];
    eprintf("DISK %s, %s:%s\n    %s\n", F->dev_name, 
                                   unks(F->vendor_name),
                                   unks(F->model_name),
                                   unks(F->serial));
    for(j=0;j<F->nparts;j++) eprintf("   (%s-%s)\n", F->parts[j]->name ,
                                               unks(F->parts[j]->mounted));
  }
  gui_run();

  return 0;
}


CPROTO void double_click_device(int nr,int mu)
{
  int R;
  exit_arg= NULL;
  R= device_operation(nr,mu);
  if (mu=='m' && !R && exit_arg)
  {
    char *argv[100]; int i;
    i= 0;
    if (settings.G_file_browser && settings.file_browser[0])
       argv[i++]= strdup(settings.file_browser);
    else
       argv[i++]= strdup("/usr/bin/xdg-open");
    argv[i++]= mprintf("/media/%s", exit_arg);
    argv[i++]= NULL;
    if (!run_prg(argv)) exit(0);
  }
}

int device_operation(int nr,int mu)
{
  disk_t *D;
  part_t *P;
  int i;
  int R;

  if ((P=find_part_gui_nr(nr, &D))) goto do_part;
  if ((D=find_disk_gui_nr(nr)))     goto do_disk;
  eprintf("Internal error: couldn't find device with gui number %d\n", nr);
  return 1;


do_part:
  eprintf("%smount partition %s of %s\n", mu=='u' ? "un" : "", 
                                       P->name, D->dev_name);
  if (mu=='u') { R= umount_part(D,P); goto done; }
  R= mount_part(D,P);
  goto done;

do_disk:
  eprintf("%smount all partitions of %s\n", mu=='u' ? "un" : "", 
                                        D->dev_name);
  if (mu=='u')
  {
    R= 0;
    for(i=0;i<D->nparts;i++) R|= umount_part(D,D->parts[i]);
    goto done;
  }
  R= 0;
  for(i=0;i<D->nparts;i++) R|= mount_part(D, D->parts[i]);

done:
  refresh_display();
  return R;
}

CPROTO void click_device(int nr, int source)
{
  if (source=='m') gui_clear_selection(MW->ud_unmounted);
  else gui_clear_selection(MW->ud_mounted);
}

CPROTO void click_mount_button(int mu)
{
  int nr;
  if (!gui_list_get_selected(MW->ud_unmounted,&nr))
    if (!gui_list_get_selected(MW->ud_mounted,&nr))
      return ;
  device_operation(nr, mu);
}


CPROTO void click_devopt()
{
  int nr;
  disk_t *D; part_t *P;

  if (!gui_list_get_selected(MW->ud_unmounted,&nr))
    if (!gui_list_get_selected(MW->ud_mounted,&nr))
      return ;

  if (!(P=find_part_gui_nr(nr, &D)))
    if (!(D=find_disk_gui_nr(nr)))
      return ;
  
  DW= gui_c_devopt(MW->self);
  start_devopts(D);
  gui_execute(*DW);
  DW= NULL;
}

